using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using RobotLib;

namespace RobotClientWpf
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Robot.Instance.Connect("host", 1818);
            Robot.Instance.Battery.BatteryChanged += BatteryChanged;
        }

        private void BatteryChanged(object? sender, BatteryEventArgs e)
        {
            if (!Dispatcher.CheckAccess())
            {
                EventHandler<BatteryEventArgs> eventDelegate = BatteryChanged;
                Dispatcher.Invoke(eventDelegate, sender, e);
            }
            else
            {
                labelBattery.Content = $"Battery: {e.Voltage} V";
            }
        }

        private void buttonBuzz_Click(object sender, RoutedEventArgs e)
        {
            Robot.Instance.Buzzer.Beep(300, 500);
        }
    }
}
